<HTML>
 <HEAD>
  <TITLE>
   mobile map by petschge.de &amp; lusiardi.de
  </TITLE>
  <META name="author" content="Petschge, n0ob">
  <META name="date" content="2009-01-25">
  <META name="robots" content="index">
  <META http-equiv="content-type" content="text/html; charset=iso-8859-1">
  <META name="generator" content="vim 7.0">
  <LINK rel="shortcut icon" href="/favicon.ico">
  <LINK rel="stylesheet" type="text/css" href="style.css">
 </HEAD>
 <BODY>
 <H1>GPX Upload</H1>
<?php
include("config.php");
include("func.php");

function genRandString($length) {
	$letters = '1234567890qwertyuiopasdfghjklzxcvbnm';
	$s = '';
	$lettersLength = strlen($letters)-1;
	for($i = 0 ; $i < $length ; $i++) {
		$s .= $letters[rand(0,$lettersLength)];
	}
	return $s;
}

function diskspace($dir) {
	$s = stat($dir);
	$space = $s["size"];
	if (is_dir($dir)) {
		$dh = opendir($dir);
		while (($file = readdir($dh)) !== false) {
			if ($file != "." and $file != "..") {
				$space += diskspace($dir."/".$file);
			}
		}
		closedir($dh);
	}
	return $space;
}

	$handle = genRandString(12);
	$uploadfile = $uploaddir . $handle . ".gpx";

	if(diskspace($uploaddir) + $_FILES['gpxfile']['size'] > $maxdirsize) {
		echo "Not enough diskspace left. Sorry.\n";
	} else {
		if (!move_uploaded_file($_FILES['gpxfile']['tmp_name'], $uploadfile)) {
			echo "Could not store uploaded file. Sorry\n";
		} else {
			echo "File is valid and was successfully stored as $handle.gpx.<BR>\n";
			$dom = new DOMDocument;
			if($dom->load($uploadfile)) {
				$gpx_nodes = $dom->getElementsByTagName("gpx");
				$namespace = "";
				foreach($gpx_nodes as $node) {
					$namespace = $node->getAttribute("xmlns");
				}
				$xpath = new DOMXPath($dom);
				//$xpath->registerNameSpace("g", "http://www.topografix.com/GPX/1/1");
				$xpath->registerNameSpace("g", $namespace);
				$nodes = $xpath->query('//g:trkpt');
				$minlat = 90;
				$maxlat = -90;
				$minlon = 180;
				$maxlon = -180;
				foreach($nodes as $node) {
					$lat = getAttributeFromElement($node, "lat");
					$lon = getAttributeFromElement($node, "lon");
					if($lat < $minlat) { $minlat = $lat; }
					if($lat > $maxlat) { $maxlat = $lat; }
					if($lon < $minlon) { $minlon = $lon; }
					if($lon > $maxlon) { $maxlon = $lon; }
				}
			}
			echo "It covers $minlat - $maxlat latitude and $minlon - $maxlon longitude<BR>\n";
			$lat = ($minlat + $maxlat ) / 2;
			$lon = ($minlon + $maxlon ) / 2;
			$deltaX = getTileX($maxlon, 17) - getTileX($minlon, 17);
			$deltaY = getTileY($maxlat, 17) - getTileY($minlat, 17);
			$delta = max(abs($deltaX), abs($deltaY));
			$zoom = 17-(int)(log($delta)/log(2));
			echo "DeltaX is $deltaX, DeltaY is $deltaY, zoom is $zoom<BR>\n";
			echo "<A href=\"map.php?lat=$lat&lon=$lon&zoom=$zoom&gpx=$handle.gpx\">Map Overlay</A>\n";
		}
	}
?>
 </BODY>
</HTML>
