<?php
	Header("Content-type: image/png");

	// times 4 for antialiasing
	$width=4*$_REQUEST["width"];
	$height=4*$_REQUEST["height"];
	$dir=$_REQUEST["dir"];

	if($dir == "up") {
		$angle = 0;
	} else if($dir == "down") {
		$angle = pi();
	} else if($dir == "right") {
		$angle = pi()/2;
	} else if($dir == "left") {
		$angle = 3* pi() / 2;
	}

	$im = ImageCreateTrueColor($width, $height);

	$white = ImageColorAllocate($im, 255, 255, 255);
	$blue = ImageColorAllocate($im, 0, 0, 255);

	ImageFilledRectangle($im, 0, 0, $width, $height, $blue);
	if($dir != "none") {
		$points=array();
		// center of the image
		$cx = $width / 2;
		$cy = $height / 2;
		// height of the triangle
		$h = min($width, $height);
		for($i = 0; $i < 3; $i++) {
			// note that the center of gravity of the triangle has to be "lower" than
			// the center of the image
			$x=$cx - $h * sin($angle) / 6  + 2 * $h * sin($angle + $i * 2 * pi() / 3) / 3;
			$y=$cy + $h * cos($angle) / 6  - 2 * $h * cos($angle + $i * 2 * pi() / 3) / 3;
			$points[] = $x;
			$points[] = $y;
		}
		ImageFilledPolygon($im, $points, 3, $white);
	}

	// create the image we want to output
	$out = ImageCreateTrueColor($width/4, $height/4);
	// downsample
	ImageCopyResampled($out, $im, 0, 0, 0, 0, $width/4, $height/4, $width, $height);
	ImagePng($out);
	ImageDestroy($out);
	ImageDestroy($im);
?>
